Loading...
Searching...
No Matches
Ogre::Volume::Source Class Referenceabstract
Optional Components » Volume

Abstract class defining the density function. More...

`#include <OgreVolumeSource.h>`

Inheritance diagram for Ogre::Volume::Source:
[legend]

## Public Member Functions

virtual | ~Source (void)
| Destructor.
bool | getFirstRayIntersection (const Ray &ray, Vector3 &result, Real scale=(Real) 1.0, size_t maxIterations=5000, Real maxDistance=(Real) 10000.0) const
| Gets the first intersection of a ray with the volume.
virtual Real | getValue (const Vector3 &position) const =0
| Gets the density value at a specific position.
virtual Vector4 | getValueAndGradient (const Vector3 &position) const =0
| Gets the density value and gradient at a specific position.
Real | getVolumeSpaceToWorldSpaceFactor (void) const
| Gets a factor to come from volume coordinate to world coordinate.
void | serialize (const Vector3 &from, const Vector3 &to, float voxelWidth, const String &file)
| Serializes a volume source to a discrete grid file with deflated compression.
void | serialize (const Vector3 &from, const Vector3 &to, float voxelWidth, Real maxClampedAbsoluteDensity, const String &file)
| Same as the other serialize function but with a user definable maximum absolute density value.

## Static Public Attributes

static const size_t | SERIALIZATION_CHUNK_SIZE
| The amount of items being written as one chunk during serialization.
static const uint32 | VOLUME_CHUNK_ID
| The id of volume files.
static const uint16 | VOLUME_CHUNK_VERSION
| The version of volume files.

## Detailed Description

Abstract class defining the density function.

## Constructor & Destructor Documentation

## ~Source()

virtual Ogre::Volume::Source::~Source | ( | void |  | ) |

virtual

Destructor.

## Member Function Documentation

## getValueAndGradient()

virtual Vector4 Ogre::Volume::Source::getValueAndGradient | ( | const Vector3 & | position | ) | const

pure virtual

Gets the density value and gradient at a specific position.

Parameters

  position | The position.

Returns
  A vector with x, y, z containing the gradient and w containing the density.

Implemented in Ogre::Volume::CacheSource, Ogre::Volume::CSGCubeSource, Ogre::Volume::CSGDifferenceSource, Ogre::Volume::CSGIntersectionSource, Ogre::Volume::CSGNegateSource, Ogre::Volume::CSGNoiseSource, Ogre::Volume::CSGPlaneSource, Ogre::Volume::CSGScaleSource, Ogre::Volume::CSGSphereSource, Ogre::Volume::CSGUnionSource, and Ogre::Volume::GridSource.

## getValue()

virtual Real Ogre::Volume::Source::getValue | ( | const Vector3 & | position | ) | const

pure virtual

Gets the density value at a specific position.

Parameters

  position | The position.

Returns
  The density.

Implemented in Ogre::Volume::CacheSource, Ogre::Volume::CSGCubeSource, Ogre::Volume::CSGDifferenceSource, Ogre::Volume::CSGIntersectionSource, Ogre::Volume::CSGNegateSource, Ogre::Volume::CSGNoiseSource, Ogre::Volume::CSGPlaneSource, Ogre::Volume::CSGScaleSource, Ogre::Volume::CSGSphereSource, Ogre::Volume::CSGUnionSource, and Ogre::Volume::GridSource.

## serialize() [1/2]

void Ogre::Volume::Source::serialize | ( | const Vector3 & | from,
|  | const Vector3 & | to,
|  | float | voxelWidth,
|  | const String & | file )

Serializes a volume source to a discrete grid file with deflated compression.

To achieve better compression, all density values are clamped within a maximum absolute value of (to - from).length() / 16.0. The values are scanned in this inner-loop-order: z, x, y. y last because there is usually the least isosurface intersection to be expected in the use case of terrain and so more often the maximum density value hit. The values are written as 16 Bit floats to save space. Note that this process is not lossless, the tradeoff is between accuracy of the source-reproduction (smaller voxelWidth) and smaller filesize (bigger voxelWidth).

Parameters

  from | The start point to scan the volume.
  to | The end point to scan the volume.
  voxelWidth | The width of a single cube in the density grid.
  file | The file to write the grid to.

## serialize() [2/2]

void Ogre::Volume::Source::serialize | ( | const Vector3 & | from,
|  | const Vector3 & | to,
|  | float | voxelWidth,
|  | Real | maxClampedAbsoluteDensity,
|  | const String & | file )

Same as the other serialize function but with a user definable maximum absolute density value.

Parameters

  from | The start point to scan the volume.
  to | The end point to scan the volume.
  voxelWidth | The width of a single cube in the density grid.
  maxClampedAbsoluteDensity | The maximum absolute density value to be written into the file, influencing the compression rate.
  file | The file to write the grid to.

## getFirstRayIntersection()

bool Ogre::Volume::Source::getFirstRayIntersection | ( | const Ray & | ray,
|  | Vector3 & | result,
|  | Real | scale = (Real) 1.0,
|  | size_t | maxIterations = 5000,
|  | Real | maxDistance = (Real) 10000.0 ) const

Gets the first intersection of a ray with the volume.

If you are using this together with the VolumeChunk: Beware of the possible scaling or other transformations you did on the Chunk! Do the inverse first on the ray origin. Example of a scaling with the factor 10: ray.setOrigin(ray.getOrigin() / (Real)10.0);

Parameters

  ray | The ray.
  result | Will hold the intersection point if there is an intersection.
  scale | The scaling of the volume compared to the world.
  maxIterations | The maximum amount of iterations on the ray before giving up.
  maxDistance | The maximum distance of the intersection point.

## getVolumeSpaceToWorldSpaceFactor()

Real Ogre::Volume::Source::getVolumeSpaceToWorldSpaceFactor | ( | void |  | ) | const

Gets a factor to come from volume coordinate to world coordinate.

Returns
  The factor, 1.0 in the default implementation.

## Member Data Documentation

## VOLUME_CHUNK_ID

const uint32 Ogre::Volume::Source::VOLUME_CHUNK_ID

static

The id of volume files.

## VOLUME_CHUNK_VERSION

const uint16 Ogre::Volume::Source::VOLUME_CHUNK_VERSION

static

The version of volume files.

## SERIALIZATION_CHUNK_SIZE

const size_t Ogre::Volume::Source::SERIALIZATION_CHUNK_SIZE

static

The amount of items being written as one chunk during serialization.

The documentation for this class was generated from the following file:

- OgreVolumeSource.h